<template>
	<f7-page 
        name="freebiescomment" 
        @page:beforein="onPageBeforeIn" 
        no-toolbar
        infinite
        :infinite-top="true"
        :infinite-distance="50"
        :infinite-preloader="showPreloader"
        @infinite="loadMore">
		<!-- Top Navbar -->
		<f7-navbar :sliding="false" large>
			<f7-nav-left back-link></f7-nav-left>
            <f7-nav-title v-if="freebie != null" class="show-small-title">{{ freebie.title }}</f7-nav-title>
            <f7-nav-title-large>Komentar</f7-nav-title-large>
		</f7-navbar>
        <f7-messagebar
            placeholder="Ketik komentar"
            ref="messagebar"
            :attachments-visible="medias.length > 0"
            :sheet-visible="false"
            style="max-height: 200px">
            <f7-link
                icon-ios="f7:attachment"
                icon-aurora="f7:attachment"
                icon-md="material:attachment"
                slot="inner-start"
                @click="handleUpload"
            ></f7-link>
            <f7-link
                icon-ios="f7:paper_plane"
                icon-aurora="f7:paper_plane"
                icon-md="material:send"
                slot="inner-end"
                @click="doSubmit"
            ></f7-link>
            <f7-messagebar-attachments>
                <f7-messagebar-attachment
                v-for="(image, index) in medias"
                :key="index"
                :image="image.url.original"
                @attachment:delete="handleMediaDelete(image.id)"
                ></f7-messagebar-attachment>
            </f7-messagebar-attachments>
        </f7-messagebar>
        <f7-messages ref="messages" :scrollMessages="false">
            <f7-message
                class="message-first message-last message-tail message-appeared"
                v-for="(comment, index) in comments"
                :key="index"
                :type="comment.user.id == user.id ? 'sent' : 'received'"
                :name="comment.user.profile.fullname"
                :avatar="comment.user.profile.media != null ? comment.user.profile.media.url.small : require('../assets/no-profile-photo.png')" 
            >            
            <span slot="text" v-if="comment.comment" v-html="comment.comment">{{ comment.comment }}</span>
            <div v-if="comment.medias.length > 0" slot="bubble-end">
                <div v-if="comment.medias.length > 0" class="attachments">
                    <a href="#" @click="handleAttachment($event, comment)" class="attachment" v-for="media in comment.medias" v-bind:key="media.id">
                        <img :src="media.url.small" width="64" class="img-rounded">
                    </a>
                </div>
            </div>
            <small slot="content-end" class="message-date">{{ dateFormat(comment.updated) }}</small>
            </f7-message>
        </f7-messages>
        <f7-block v-if="comments.length == 0" style="height: calc(100% - 100px);position:absolute;top:0;left:0;width:100%;">
			<span class="display-flex align-items-center justify-content-center" style="height:calc(100% - 100px);">
				<span class="text-align-center">
					<span class="display-block text-align-center">
						<f7-icon material="speaker_notes_off" style="font-size:100px;color:#eee;"></f7-icon>
						<span class="display-block">It's a little quiet here</span>
					</span>
				</span>
			</span>
		</f7-block>
    </f7-page>
</template>
<script>
import { mapGetters } from 'vuex';
import { dateFormat, parseError } from '../js/utils';
import { setTimeout } from 'timers';
export default {
    name: 'FreebiesComment',
    data(){
        return{
            allowInfinite: true,
            showPreloader: true,
            commentForm: {
                comment: '',
                latitude: null,
                longitude: null,
                mapurl: null,
                medias: []
            },
            medias: []
        }
    },
    computed: {
        ...mapGetters('auth', ['user']),
        ...mapGetters('freebies', ['freebie']),
        ...mapGetters('comment', [
            'comments',
            'pagination'
        ]),
        currentLocation: function(){
			const self = this;

			let currentLocation = localStorage.getItem('currentLocation') ? JSON.parse(localStorage.getItem('currentLocation')) : null;
			return currentLocation;
		}
    },
    mounted() {
        const self = this;
        const app = self.$f7;
        const $$ = self.$$;

        self.$f7ready(() => {
            self.messagebar = self.$refs.messagebar.f7Messagebar;
            self.messagesText = self.$refs.messages.f7Messages;

            $$('div[data-name="freebiescomment"] textarea').on('focus', function(){
                var height = $$('.messages-content')[0].scrollHeight;
                $$('.messages-content').scrollTop( height, 1000 );
            });

            $$('div[data-name="freebiescomment"]').on('click', 'a.geo', function(){
                let href = $$(this).data('href');
                location.href = href;
            });
        });
    },
    methods: {
        dateFormat,
        getFreebie(){
            const self = this;
			const app = self.$f7;
			const $$ = self.$$;
            const $el = $$(self.$el);

            self.$store.dispatch('freebies/viewFreebie',{
                id: self.$f7route.params.id,
                only: 'id,title,slug,description,latitude,longitude,created,updated,medias.id,medias.mimetype,medias.url,medias.filename,medias.original_filename,author.id,author.profile,author.profile.fullname,author.profile.initial,author.profile.media,total_comment'
            }).then((response) => {
                app.preloader.hide();
            });
        },
        getComments(page, loadmore){
            const self = this;
			const app = self.$f7;
			const $$ = self.$$;
            const $el = $$(self.$el);

            var heightBefore = $$('.messages-content')[0].scrollHeight;

            app.preloader.show('green');

            self.$store.dispatch('comment/getComments', {
                freebies: self.$f7route.params.id,
                page: page,
                perpage: 25,
                loadmore: loadmore,
                only: 'id,comment,latitude,longitude,mapurl,created,updated,user.profile.fullname,user.profile.media,medias'
            }).then((response) => {
                self.showPreloader = self.pagination.has_next;
                app.preloader.hide();   
                var heightAfter = $$('.messages-content')[0].scrollHeight;
                $$('.messages-content').scrollTop( (heightAfter - heightBefore), 1000 );
            });
        },
        onPageBeforeIn(){
            const self = this;
			const app = self.$f7;
			const $$ = self.$$;
            const $el = $$(self.$el);
            
            self.getFreebie();
            self.getComments(1, false);
            
        },
        handleUpload(){
			const self = this;
			const app = self.$f7;

			var ac = app.actions.create({
                buttons: [
                    {
                        text: 'Kamera', onClick: function () {
                            app.methods.takePicture(Camera.PictureSourceType.CAMERA)
                                .then(function (bannerImagePath) {
                                    app.preloader.show('green');

                                    var payload = {url: '/media/tmp', imagePath: bannerImagePath, key: 'media', method: 'POST'};

                                    if(self.formType == 'Ubah'){
                                        payload = {url: '/media/comment/'+self.$f7route.params.id, imagePath: bannerImagePath, key: 'media', method: 'POST'};
                                    }

                                    app.methods.storePicture(payload)
                                        .then(function (r) {
                                            var response = JSON.parse(r.response);
                                            self.commentForm.medias.push(response.data.media.id);
                                            self.medias.push(response.data.media);
                                            app.preloader.hide();
                                        })
                                        .catch(function (e) {
                                            app.preloader.hide();
                                        });
                                });
                        }
                    },
                    {
                        text: 'Galeri', onClick: function () {
                            app.methods.takePicture(Camera.PictureSourceType.PHOTOLIBRARY)
                                .then(function (bannerImagePath) {
                                    app.preloader.show('green');

                                    var payload = {url: '/media/tmp', imagePath: bannerImagePath, key: 'media', method: 'POST'};

                                    if(self.formType == 'Ubah'){
                                        payload = {url: '/media/comment/'+self.$f7route.params.id, imagePath: bannerImagePath, key: 'media', method: 'POST'};
                                    }

                                    app.methods.storePicture(payload)
                                    .then(function (r) {
                                        var response = JSON.parse(r.response);

                                        self.commentForm.medias.push(response.data.media.id);
                                        self.medias.push(response.data.media);

                                        app.preloader.hide();
                                    })
                                    .catch(function (e) {
                                        app.preloader.hide();
                                    });

                                });
                        }
                    },
                    {
                        text: 'Lokasi', 
                        onClick: function(action, e){
                            if(self.currentLocation != null){
                                self.commentForm.latitude = self.currentLocation.latitude;
                                self.commentForm.longitude = self.currentLocation.longitude;

                                app.dialog.alert('Lokasi berhasil dilampirkan. Silahkan tulis komentar untuk melanjutkan.', 'RingSatu');
                            }else{
                                app.dialog.alert('Gagal melakukan permintaan data lokasi. Silahkan aktifkan fitur lokasi dari handphone anda.', 'RingSatu');
                            }
                        }
                    },
                    {
                        text: 'Batal', color: 'red'
                    }
                ]
            });

            ac.open();
        },
        handleMediaDelete(imageId){
			const self = this;
			const app = self.$f7;
			const $$ = self.$$;

			app.dialog.confirm('Anda akan menghapus media ini. File tidak bisa dikembalikan setelah dihapus. Anda yakin?', 'Hapus File', function(){
				app.preloader.show('green');

				self.$store.dispatch('media/deleteMedia', {
					id: parseInt(imageId),
					endpoint: 'comment'
				}).then((response) => {
					for(let [i,x] of self.medias){
                        if(x.id == imageId){
                            self.medias.splice(i, 1);
                        }
                    }
					app.preloader.hide();
				});
			})
        },
        loadMore() {
            const self = this;

            if (!self.allowInfinite) return;
            self.allowInfinite = false;
            setTimeout(()=>{
                if(self.pagination.has_next){                
                    self.getComments(self.pagination.page + 1, true);
                    self.allowInfinite = true;
                }else{
                    self.showPreloader = false;
                }
            }, 1000);
        },
        doSubmit(){
            const self = this;
			const app = self.$f7;
			const $$ = self.$$;
            const $el = $$(self.$el);

            const comment = self.messagebar.getValue().replace(/\n/g, '<br>').trim();
            if(comment.length == 0) return;

            app.preloader.show('green');

			let params = {};

			params.comment = comment;
			params.latitude = self.commentForm.latitude;
            params.longitude = self.commentForm.longitude;
            params.mapurl = self.commentForm.mapurl;
            params.medias = self.commentForm.medias;
            params.freebies = parseInt(self.$f7route.params.id);
            params.user = self.user.id;
			params.only = 'id,comment,mapurl,latitude,longitude,created,updated,user.id,user.phone,user.profile.fullname,user.profile.media,medias';

			self.$store.dispatch('comment/createComment', params).then((response) => {
				app.preloader.hide();

				if('errors' in response){
					let error = parseError(response.errors);
					app.dialog.alert(error.messages, 'RingSatu');
					return false;
				}else{                    
                    self.messagebar.clear();
                    self.commentForm = {
                        comment: '',
                        latitude: null,
                        longitude: null,
                        mapurl: null,
                        medias: []
                    };
                    self.medias = [];

                    var heightAfter = $$('.messages-content')[0].scrollHeight;
                    $$('.messages-content').scrollTop( heightAfter, 1000 );
				}
			});

        },
        handleAttachment(e, comment){
            const self = this;
            const app = self.$f7;
            const $$ = self.$$;

            let attachmentMedias = comment.medias.map((x) => x.url.original);
            let photoBrowser = app.photoBrowser.create({
                photos: attachmentMedias,
                type: 'popup'
            }).open();
        }
    }
}
</script>
